/**
  * This file was generated from model [ReadController] on [Sun Apr 27 17:19:14 CDT 2008].
  * Do not change content of this file.
  */
package org.cleversafe.layer.grid.smartcontroller;

import java.io.IOException;
import java.util.*;

import org.apache.commons.lang.BooleanUtils;
import org.apache.commons.lang.math.NumberUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.debug.app.AppDebugger;
import com.evelopers.unimod.debug.protocol.JavaSpecificMessageCoder;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;
import com.evelopers.unimod.runtime.logger.SimpleLogger;


public class ReadControllerEventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int ReadMachine = 1;
	
	private int decodeStateMachine(String sm) {
					
		if ("ReadMachine".equals(sm)) {
			return ReadMachine;
			}

		return -1;
	}
		
			private ReadMachineEventProcessor _ReadMachine;
		
	public ReadControllerEventProcessor() {
		modelStructure = new ReadControllerModelStructure();

					_ReadMachine = new ReadMachineEventProcessor();
			}

		    public static void run(int debuggerPort, boolean debuggerSuspend) throws 
						            InterruptedException, EventProcessorException, CommonException, 
        			    IOException {

        		/* Create runtime engine */
        		ModelEngine engine = createModelEngine(true);

		        /* Setup logger */
		        final Log log = LogFactory.getLog(ReadControllerEventProcessor.class);
        		engine.getEventProcessor().addEventProcessorListener(new SimpleLogger(log));

        		/* Setup exception handler */
        		engine.getEventProcessor().addExceptionHandler(new ExceptionHandler() {
		            public void handleException(StateMachineContext context, SystemException e) {
                				log.fatal(e.getChainedMessage(), e.getRootException());
		            }
		        });

        		if (debuggerPort > 0) {
            			AppDebugger d = new AppDebugger(
            					        debuggerPort, debuggerSuspend,
                    					new JavaSpecificMessageCoder(), engine);
                    			d.start();
            		}
            		engine.start();
        	}

    	public static void main(String[] args) throws Exception {
		        int debuggerPort = NumberUtils.stringToInt(System.getProperty("debugger.port"), -1);
        		boolean debuggerSuspend = BooleanUtils.toBoolean(System.getProperty("debugger.suspend"));
        		ReadControllerEventProcessor.run(debuggerPort, debuggerSuspend);
    	}

    	public static ModelEngine createModelEngine(boolean useEventQueue) throws CommonException {
        	ObjectsManager objectsManager = new ObjectsManager();
        	return ModelEngine.createStandAlone(
        		        useEventQueue ? (EventManager) new QueuedHandler() : (EventManager) new StrictHandler(), 
        		        new ReadControllerEventProcessor(),
                objectsManager.getControlledObjectsManager(),
                objectsManager.getEventProvidersManager());
	    }

	    public static class ObjectsManager {
	        private org.cleversafe.layer.grid.smartcontroller.ReadStateMachine world = null;
	    
	        private ControlledObjectsManager controlledObjectsManager = new ControlledObjectsManagerImpl();
	        private EventProvidersManager eventProvidersManager = new EventProvidersManagerImpl();

	        public ControlledObjectsManager getControlledObjectsManager() {
	            return controlledObjectsManager;
	        }

	        public EventProvidersManager getEventProvidersManager() {
	            return eventProvidersManager;
	        }

	        private class ControlledObjectsManagerImpl implements ControlledObjectsManager {
	            public void init(ModelEngine engine) throws CommonException {}

	            public void dispose() {}

	            public ControlledObject getControlledObject(String coName) {
                if (StringUtils.equals(coName, "world")) {
                		    if (world == null) {
                		        world = new org.cleversafe.layer.grid.smartcontroller.ReadStateMachine();
                		    }
                		    return world;
                }
	                throw new IllegalArgumentException("Controlled object with name [" + coName + "] wasn't found");
	            }
	        }

	        private class EventProvidersManagerImpl implements EventProvidersManager {
	            private List nonameEventProviders = new ArrayList();

	            public void init(ModelEngine engine) throws CommonException {
	                EventProvider ep;
	            }

	            public void dispose() {
	                	EventProvider ep;
	                for (Iterator i = nonameEventProviders.iterator(); i.hasNext();) {
                    ep = (EventProvider) i.next();
                    ep.dispose();
                }
            }

	            public EventProvider getEventProvider(String epName) {
	                throw new IllegalArgumentException("Event provider with name [" + epName + "] wasn't found");
	            }
	        }
    	}
	
    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_ReadMachine.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case ReadMachine:
				return _ReadMachine.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case ReadMachine:
				return _ReadMachine.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	
	
private class ReadControllerModelStructure implements ModelStructure {
	    private Map configManagers = new HashMap();

    private ReadControllerModelStructure() {
		        configManagers.put("ReadMachine", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
		    }

	    public StateMachinePath getRootPath() 
	            throws EventProcessorException {
	        	return new StateMachinePath("ReadMachine");				
	    }

	    public StateMachineConfigManager getConfigManager(String stateMachine) 
	            throws EventProcessorException {
		        return (StateMachineConfigManager)configManagers.get(stateMachine);
	    }

	    public StateMachineConfig getTopConfig(String stateMachine) 
	            throws EventProcessorException {
        		int sm = decodeStateMachine(stateMachine);
		
		        switch (sm) {
					            case ReadMachine:
                				return new StateMachineConfig("Top");
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }

    	public boolean isFinal(String stateMachine, StateMachineConfig config) 
    	        throws EventProcessorException {
		        /* Get state machine from path */
        		int sm = decodeStateMachine(stateMachine);
        		int state;
		        		switch (sm) {
					            case ReadMachine:
                				state = _ReadMachine.decodeState(config.getActiveState());
				                switch (state) {
																																																																																		                    case ReadMachineEventProcessor.Success:
																				                    case ReadMachineEventProcessor.Exception:
																		                        return true;
				                    					default:
                    						    return false;
                	}
					            default:
                				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		        }
	    }			
}
	
			







private class ReadMachineEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int Start = 2;
	    private static final int Begin_read_operations = 3;
	    private static final int Process_response = 4;
	    private static final int Decode_slices = 5;
	    private static final int Read_policy_satisfied = 6;
	    private static final int Determine_exception = 7;
	    private static final int Success = 8;
	    private static final int Exception = 9;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("Start".equals(state)) {
			return Start;
						} else 
				
		if ("Begin read operations".equals(state)) {
			return Begin_read_operations;
						} else 
				
		if ("Process response".equals(state)) {
			return Process_response;
						} else 
				
		if ("Decode slices".equals(state)) {
			return Decode_slices;
						} else 
				
		if ("Read policy satisfied".equals(state)) {
			return Read_policy_satisfied;
						} else 
				
		if ("Determine exception".equals(state)) {
			return Determine_exception;
						} else 
				
		if ("Success".equals(state)) {
			return Success;
						} else 
				
		if ("Exception".equals(state)) {
			return Exception;
			}
		
		return -1;
	}
	
		// events
	    private static final int yes = 1;
	    private static final int slice_store_task_exception = 2;
	    private static final int no = 3;
	    private static final int read_success = 4;
	    private static final int ok = 5;
	    private static final int impossible_to_satisfy = 6;
	
	private int decodeEvent(String event) {
					
		if ("yes".equals(event)) {
			return yes;
						} else 
				
		if ("slice_store_task_exception".equals(event)) {
			return slice_store_task_exception;
						} else 
				
		if ("no".equals(event)) {
			return no;
						} else 
				
		if ("read_success".equals(event)) {
			return read_success;
						} else 
				
		if ("ok".equals(event)) {
			return ok;
						} else 
				
		if ("impossible_to_satisfy".equals(event)) {
			return impossible_to_satisfy;
				}
	
		return -1;
	}
		
							private org.cleversafe.layer.grid.smartcontroller.ReadStateMachine world;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									world = (org.cleversafe.layer.grid.smartcontroller.ReadStateMachine)controlledObjectsMap.getControlledObject("world");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case Start: 
					
											return;
																					case Begin_read_operations: 
					
											return;
																					case Process_response: 
					
											return;
																					case Decode_slices: 
					
											return;
																					case Read_policy_satisfied: 
					
											return;
																					case Determine_exception: 
					
											return;
																					case Success: 
					
											return;
																					case Exception: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [ReadMachine]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "Start");

					// Start->Begin read operations [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "Start", event, "Start#Begin read operations##true");
	
		
	fireComeToState(context, path, "Begin read operations");
	
	// Begin read operations [world.beginReadOperations]
				fireBeforeOutputActionExecution(context, path, "Start#Begin read operations##true", "world.beginReadOperations");

				world.beginReadOperations(context);
		
	fireAfterOutputActionExecution(context, path, "Start#Begin read operations##true", "world.beginReadOperations");
						
											return new StateMachineConfig("Begin read operations");
																																																				}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case Begin_read_operations:
						
											
												switch (e) {
													case ok:
																
						// Begin read operations->Process response ok[true]/
			
			fireTransitionCandidate(context, path, "Begin read operations", event, "Begin read operations#Process response#ok#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Begin read operations", event, "Begin read operations#Process response#ok#true");
	
		
	fireComeToState(context, path, "Process response");
	
	// Process response []
					return new StateMachineConfig("Process response");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Process_response:
						
											
												switch (e) {
													case slice_store_task_exception:
																
						// Process response->Read policy satisfied slice_store_task_exception[true]/world.sliceStoreTaskException
			
			fireTransitionCandidate(context, path, "Process response", event, "Process response#Read policy satisfied#slice_store_task_exception#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Process response", event, "Process response#Read policy satisfied#slice_store_task_exception#true");
	
				fireBeforeOutputActionExecution(context, path, "Process response#Read policy satisfied#slice_store_task_exception#true", "world.sliceStoreTaskException");

				world.sliceStoreTaskException(context);
		
	fireAfterOutputActionExecution(context, path, "Process response#Read policy satisfied#slice_store_task_exception#true", "world.sliceStoreTaskException");
		
	fireComeToState(context, path, "Read policy satisfied");
	
	// Read policy satisfied [world.checkReadPolicySatisfied]
				fireBeforeOutputActionExecution(context, path, "Process response#Read policy satisfied#slice_store_task_exception#true", "world.checkReadPolicySatisfied");

				world.checkReadPolicySatisfied(context);
		
	fireAfterOutputActionExecution(context, path, "Process response#Read policy satisfied#slice_store_task_exception#true", "world.checkReadPolicySatisfied");
					return new StateMachineConfig("Read policy satisfied");

																				
														case read_success:
																
						// Process response->Decode slices read_success[true]/world.decodeSlices
			
			fireTransitionCandidate(context, path, "Process response", event, "Process response#Decode slices#read_success#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Process response", event, "Process response#Decode slices#read_success#true");
	
				fireBeforeOutputActionExecution(context, path, "Process response#Decode slices#read_success#true", "world.decodeSlices");

				world.decodeSlices(context);
		
	fireAfterOutputActionExecution(context, path, "Process response#Decode slices#read_success#true", "world.decodeSlices");
		
	fireComeToState(context, path, "Decode slices");
	
	// Decode slices []
					return new StateMachineConfig("Decode slices");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Decode_slices:
						
											
												switch (e) {
													case ok:
																
						// Decode slices->Read policy satisfied ok[true]/
			
			fireTransitionCandidate(context, path, "Decode slices", event, "Decode slices#Read policy satisfied#ok#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Decode slices", event, "Decode slices#Read policy satisfied#ok#true");
	
		
	fireComeToState(context, path, "Read policy satisfied");
	
	// Read policy satisfied [world.checkReadPolicySatisfied]
				fireBeforeOutputActionExecution(context, path, "Decode slices#Read policy satisfied#ok#true", "world.checkReadPolicySatisfied");

				world.checkReadPolicySatisfied(context);
		
	fireAfterOutputActionExecution(context, path, "Decode slices#Read policy satisfied#ok#true", "world.checkReadPolicySatisfied");
					return new StateMachineConfig("Read policy satisfied");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Read_policy_satisfied:
						
											
												switch (e) {
													case yes:
																
						// Read policy satisfied->Success yes[true]/world.exitMachine
			
			fireTransitionCandidate(context, path, "Read policy satisfied", event, "Read policy satisfied#Success#yes#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Read policy satisfied", event, "Read policy satisfied#Success#yes#true");
	
				fireBeforeOutputActionExecution(context, path, "Read policy satisfied#Success#yes#true", "world.exitMachine");

				world.exitMachine(context);
		
	fireAfterOutputActionExecution(context, path, "Read policy satisfied#Success#yes#true", "world.exitMachine");
		
	fireComeToState(context, path, "Success");
	
	// Success []
					return new StateMachineConfig("Success");

																				
														case no:
																
						// Read policy satisfied->Begin read operations no[true]/
			
			fireTransitionCandidate(context, path, "Read policy satisfied", event, "Read policy satisfied#Begin read operations#no#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Read policy satisfied", event, "Read policy satisfied#Begin read operations#no#true");
	
		
	fireComeToState(context, path, "Begin read operations");
	
	// Begin read operations [world.beginReadOperations]
				fireBeforeOutputActionExecution(context, path, "Read policy satisfied#Begin read operations#no#true", "world.beginReadOperations");

				world.beginReadOperations(context);
		
	fireAfterOutputActionExecution(context, path, "Read policy satisfied#Begin read operations#no#true", "world.beginReadOperations");
					return new StateMachineConfig("Begin read operations");

																				
														case impossible_to_satisfy:
																
						// Read policy satisfied->Determine exception impossible_to_satisfy[true]/
			
			fireTransitionCandidate(context, path, "Read policy satisfied", event, "Read policy satisfied#Determine exception#impossible_to_satisfy#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Read policy satisfied", event, "Read policy satisfied#Determine exception#impossible_to_satisfy#true");
	
		
	fireComeToState(context, path, "Determine exception");
	
	// Determine exception [world.determineException]
				fireBeforeOutputActionExecution(context, path, "Read policy satisfied#Determine exception#impossible_to_satisfy#true", "world.determineException");

				world.determineException(context);
		
	fireAfterOutputActionExecution(context, path, "Read policy satisfied#Determine exception#impossible_to_satisfy#true", "world.determineException");
					return new StateMachineConfig("Determine exception");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case Determine_exception:
						
											
												switch (e) {
												default:
														
						// Determine exception->Exception *[true]/world.exitMachine
			
			fireTransitionCandidate(context, path, "Determine exception", event, "Determine exception#Exception#*#true");
			
						
							
			
							
					fireTransitionFound(context, path, "Determine exception", event, "Determine exception#Exception#*#true");
	
				fireBeforeOutputActionExecution(context, path, "Determine exception#Exception#*#true", "world.exitMachine");

				world.exitMachine(context);
		
	fireAfterOutputActionExecution(context, path, "Determine exception#Exception#*#true", "world.exitMachine");
		
	fireComeToState(context, path, "Exception");
	
	// Exception []
					return new StateMachineConfig("Exception");

																				
							}
						
																															default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [ReadMachine]");
			}
		}
	}

		        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
