//
// Cleversafe open-source code header - Version 1.1 - December 1, 2006
//
// Cleversafe Dispersed Storage(TM) is software for secure, private and
// reliable storage of the world's data using information dispersal.
//
// Copyright (C) 2005-2007 Cleversafe, Inc.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
// USA.
//
// Contact Information: Cleversafe, 10 W. 35th Street, 16th Floor #84,
// Chicago IL 60616
// email licensing@cleversafe.org
//
// END-OF-HEADER
//-----------------------
// Author: Zachary Mark
//
// Date: Jun 28, 2007
//---------------------

package org.cleversafe.layer.protocol;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.cleversafe.exceptions.BaseException;
import org.junit.Test;

/**
 * Test for the (mostly trivial) VaultBindResponse class.
 * 
 * @author Zachary Mark
 */
public class VaultBindResponseTest
{
   /**
    * Tests the only public getter/setter implemented by this class that isn't implemented in its
    * superclass.
    * 
    */
   @Test
   public void testSuccess()
   {
      VaultBindResponse response = new VaultBindResponse();
      response.setException(new BaseException("Test Exception")
      {
         private static final long serialVersionUID = 1L;
      });

      assertTrue("Response was unexpected success", response.getExceptionFlag());

      response.setException(null);

      assertFalse("Response was unexpected failure", response.getExceptionFlag());

   }

}
